<?php

/* 
    Copyright 2003 Darren Turland.

    This script provides an Index of pages for PmWiki. Similar to $search
    without any arguments.  Layout is different.

    A B C D E ....  X Y Z
    A
      AllPages.. (PmWiki)
    B
    C
    D 
      DarrenPage (Darren)
    etc..

    include_once("local/DTIndex.php"); in local.php

    then add [[$Index]] where-ever you require Index of all pages.
    
*/

SDV($InlineReplacements['/\\[\\[\\$Indexgroup\\]\\]/e'], "DTIndexGroup()");
SDV($InlineReplacements['/\\[\\[\\$Index\\]\\]/e'], "DTIndexAll()");

$ignore_pages = array('GroupAttributes','GroupHeader','GroupFooter','HomePage','RecentChanges','RecentUploads');

function DTIndexAll()
{
  global $WikiLibDirs;
  global $ignore_pages;

  for($l_loop=65;$l_loop<65+26;$l_loop++) 
    $DTIndexArray[chr($l_loop)] = "";

  foreach($WikiLibDirs as $dir) {
    $dfp = opendir($dir); if (!$dfp) continue;
    while (($pagefile=readdir($dfp))!=false) {
      
       $d1=FmtPageName('$Group',$pagefile);
       if ($d1) {
         $l_title = FmtPageName('$Title',$pagefile);

	 if ( !in_array( $l_title, $ignore_pages ) ) {
	   $l_key = substr($l_title,0, 1);

	   $pagef = array();
	   $pagef['Title'] = FmtPageName('$Title',$pagefile);
	   $pagef['Group'] = FmtPageName('$Group',$pagefile);
	   $pagef['Url'] = FmtPageName('$PageUrl',$pagefile);
	   $pagef['pagefile'] = $pagefile;
	   $DTIndexArray[$l_key][] = $pagef;
	 }
       }
    }
    closedir($dfp);
  }
  DTIndexShow($DTIndexArray);
}


function DTIndexGroup()
{
  global $WikiLibDirs;
  global $pagename;
  global $ignore_pages;

  $l_group = FmtPageName('$Group', $pagename);

  for($l_loop=65;$l_loop<65+26;$l_loop++) 
    $DTIndexArray[chr($l_loop)] = "";

  foreach($WikiLibDirs as $dir) {
    $dfp = opendir($dir); if (!$dfp) continue;
    while (($pagefile=readdir($dfp))!=false) {
      
       $d1=FmtPageName('$Group',$pagefile);
       if ($d1 && $d1==$l_group) {
         $l_title = FmtPageName('$Title',$pagefile);

	 if ( !in_array( $l_title, $ignore_pages ) ) {
	   $l_key = substr($l_title,0, 1);

	   $pagef = array();
	   $pagef['Title'] = FmtPageName('$Title',$pagefile);
//	   $pagef['Group'] = FmtPageName('$Group',$pagefile);
	   $pagef['Url'] = FmtPageName('$PageUrl',$pagefile);
	   $pagef['pagefile'] = $pagefile;
	   $DTIndexArray[$l_key][] = $pagef;
	 }
       }
    }
    closedir($dfp);
  }
  DTIndexShow($DTIndexArray);
}

function DTIndexShow($DTIndexArray) 
{
  $startid = "";
  $stopid = "";

  print "<br />";
  print "<strong><font size='+1'>";
  foreach(array_keys($DTIndexArray) as $fred) {

    /* collect empty indices */
    if ($DTIndexArray[$fred] == "") {
      if ( $startid == "" ) {
        $startid = "$fred"; /* remember first unused index */
      }	
      $stopid = $fred;
      continue;
    }

    if ( $startid != "" ) {
      if ( $startid == $stopid ) {
        print "$startid&nbsp;&nbsp;";
      } else {
        print "$startid-$stopid&nbsp;&nbsp;";
      }
    }

    print "<a href=\"#$fred\" >$fred</a>&nbsp;&nbsp;";
    $startid = "";
  }

  if ( $startid != "" ) {
    if ( $startid == $stopid ) {
      print "$startid&nbsp;&nbsp;";
    } else {
      print "$startid-$stopid&nbsp;&nbsp;";
    }
  }

  print "</font></strong>";
  print "<br />";
  print "<br />";

  $startid = "";
  $stopid = "";

  foreach(array_keys($DTIndexArray) as $fred) {

    /* collect empty indices */
    if ($DTIndexArray[$fred] == "") {
      if ( $startid == "" ) {
        $startid = "$fred"; /* remember first unused index */
      }	
      $stopid = $fred;
      continue;
    }

    if ( $startid != "" ) {
      if ( $startid == $stopid ) {
        print "<br /><strong><font size='+1'>$startid</font></strong>";
      } else {
        print "<br /><strong><font size='+1'>$startid-$stopid</font></strong>";
      }
    }

    print "<br /><a name=\"$fred\" id=\"$fred\"></a>";
    print "<strong><font size='+1'>$fred</font></strong>";
    $startid = "";
    if (is_array($DTIndexArray[$fred])) {
      sort($DTIndexArray[$fred['Title']]);  
      foreach($DTIndexArray[$fred] as $item) {
        print "<br />&nbsp;&nbsp;  " ;
        print "<a href=\"";
        print $item['Url'];
        print "\" >";
        print FmtPageName('$Title',$item['pagefile']);
        print "</a>";
	if ($item['Group']) {
          print " ( ";
          print FmtPageName('$Group',$item['pagefile']);
          print " )";
	}
      }
    }
  }

  if ( $startid != "" ) {
    if ( $startid == $stopid ) {
      print "<br /><strong><font size='+1'>$startid</font></strong>";
    } else {
      print "<br /><strong><font size='+1'>$startid-$stopid</font></strong>";
    }
  }
}

?>
